# ==================================================================
# Plugins::Community::Luna_Templates - Auto Generated Install Module
#
#   Plugins::Community::Luna_Templates
#   Author  : Jonathan Gamble
#   Version : 1.0
#   Updated : Mon Mar  7 16:18:38 2011
#
# ==================================================================
#

package Plugins::Community::Luna_Templates;
# ==================================================================
    use strict;
    use vars  qw/$VERSION $DEBUG $NAME $META $FILES @FILES @LUNA/;
    use GT::Base;
    use GT::Plugins qw/STOP CONTINUE/;
    use Community qw/$CFG $IN $DB/;

    $VERSION = '1.0';
    $DEBUG   = 0;
    $NAME    = 'Luna_Templates';
# Inhert from base class for debug and error methods
    @Plugins::Community::Luna_Templates::ISA = qw(GT::Base);

$META = {
    'author' => 'Jonathan Gamble',
    'description' => 'This will install luna templates for GCommunity 1.1.1.',
    'license' => 'Freeware',
    'prog_ver' => '1.1.1',
    'url' => 'http://www.gossamer-threads.com/forum/?post=305985',
    'version' => '1.0'
};

@FILES = qw|globals.txt
language.txt
user_email_change.eml
user_form_edit.html
user_home.html
user_include_accessibility.html
user_include_common_head.html
user_include_content_bottom.html
user_include_content_top.html
user_include_contentfooter.html
user_include_contentheader.html
user_include_contentwrapper_bottom.html
user_include_contentwrapper_top.html
user_include_footer.html
user_include_header.html
user_include_leftsidebar.html
user_include_login.html
user_include_rightsidebar.html
user_login.html
user_logout.html
user_lostpw.eml
user_lostpw.html
user_lostpw_success.html
user_multpw.eml
user_notify_admin.eml
user_profile.html
user_signup.html
user_signup_reject.eml
user_signup_reject.html
user_signup_validate.html
user_signup_validate_admin.html
user_ssi_login.html
user_tmppw.eml
user_validate.eml
user_validate_admin.eml|;

@LUNA = qw|luna.css
luna_core.css
images/betweennav.gif
images/blank.gif
images/button-left.gif
images/button-right.gif
images/collapse.gif
images/expand.gif
images/loading.gif
images/login.gif
images/logo-small.gif
images/logo.gif
images/logout.gif
images/paging-first.gif
images/paging-last.gif
images/paging-next.gif
images/paging-nofirst.gif
images/paging-nolast.gif
images/paging-nonext.gif
images/paging-noprev.gif
images/paging-prev.gif
images/poweredby.gif
images/root.gif
images/shadow-bottom.gif
images/shadow-bottomleft.gif
images/shadow-bottomright.gif
images/shadow-left.gif
images/shadow-right.gif
images/shadow-top.gif
images/shadow-topleft.gif
images/shadow-topright.gif
images/stars-10-0.gif
images/stars-10-1.gif
images/stars-10-10.gif
images/stars-10-2.gif
images/stars-10-3.gif
images/stars-10-4.gif
images/stars-10-5.gif
images/stars-10-6.gif
images/stars-10-7.gif
images/stars-10-8.gif
images/stars-10-9.gif
images/stars-5-0.gif
images/stars-5-1.gif
images/stars-5-2.gif
images/stars-5-3.gif
images/stars-5-4.gif
images/stars-5-5.gif
images/swirls.gif|;

foreach (@FILES) {
    $FILES->{$_}->{path} = "$CFG->{path_private}/templates/luna";
    $FILES->{$_}->{chmod} = '0644';
}
$FILES->{"LSSI.pm"} = {
    'path'  => "$CFG->{path_private}/lib/Community/Web",
    'chmod' => '0644'
};
$FILES->{"admin_template_set.html"} = {
    'path' => "$CFG->{path_private}/templates/default",
    'chmod' => '0644'
};

sub pre_install {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they install the plugin.
#
    my ($db_cgi_url, $static_url, $static_path);

    $static_path = $CFG->{path_cgi};
    $static_path =~ s#^(.+)/(.+?)$#$1#;
    $static_path .= "/static";
    $db_cgi_url = $CFG->{path_cgi_url};
    $db_cgi_url =~ s#^(.+)/(.+?)$#$1#;
    $static_url = $db_cgi_url;
    $static_url =~ s#^(.+)/(.+?)$#$1#;
    $static_url .= "/static";

    my $inst_msg = qq|<p>This will install Luna Templates Plugin for GCommunity. It will <b>not</b> overwrite any existing luna files.</p><br />
<table>
 <tr>
    <td align="left"><b>static_url:</b></td>
    <td align="left"><input type="text" name="static_url" value="$static_url" size="40" /> /luna</td>
  </tr>
  <tr>
    <td colspan="2" align="left"><br /><font size="1">This is the directory where your template css files and images will be stored.</font><p /></td>
   </tr>
   <tr>
    <td align="left"><b>static_path:</b></td>
    <td align="left"><input type="text" name="static_path" value="$static_path" size="40" /> /luna</td>
  </tr>
  <tr>
    <td colspan="2" align="left"><br /><font size="1">This is the path to the directory where your template css files and images will be stored.</font><p /></td>
   </tr>
   <tr>
    <td align="left"><b>db_cgi_url:</b></td>
    <td align="left"><input type="text" name="db_cgi_url" value="$db_cgi_url" size="40" /></td>
  </tr>
  <tr>
    <td colspan="2" align="left"><br /><font size="1">This is the directory where your cgi files are located.</font></td>
   </tr>
</table>
|;

    return $inst_msg;
}

sub pre_uninstall {
# -----------------------------------------------------------------------------
# This function displays an HTML formatted message that will display any
# instructions/information to the user before they remove the plugin.
#
    my $uninst_msg = 'This will uninstall Luna Templates Plugin for GCommunity. It will <b>not</b> erase any luna static files.';

    return $uninst_msg;
}

sub install {
# -----------------------------------------------------------------------------
# This function does the actual installation.  Its first argument is a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc.  The second argument is a GT::Tar object which you can use to access any
# files in your plugin module.
#
# You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Community::Luna_Templates::error
#
    my ($mgr, $tar) = @_;

    $mgr->install_hooks('Luna_Templates', [['web_admin_page', 'PRE', 'Plugins::Community::Luna_Templates::admin_template', '']]);

    $mgr->install_menu('Luna_Templates', [['Template Set', 'community.cgi?do=admin_plugin&plugin=Luna_Templates&func=changeTemplateSet']]);

    my ($db_cgi_url, $static_url, $static_path);

    $static_path = $CFG->{path_cgi};
    $static_path =~ s#^(.+)/(.+?)$#$1#;
    $static_path .= "/static";
    $db_cgi_url = $CFG->{path_cgi_url};
    $db_cgi_url =~ s#^(.+)/(.+?)$#$1#;
    $static_url = $db_cgi_url;
    $static_url =~ s#^(.+)/(.+?)$#$1#;
    $static_url .= "/static";


    $CFG->{system_template_set} = 'luna';
    $db_cgi_url = $IN->param('db_cgi_url') || $db_cgi_url;
    $static_url = $IN->param('static_url') || $static_url;
    $static_path = $IN->param('static_path') || $static_path;

# Silence warnings
    $GT::Tar::error ||= '';

    my $luna_path = $static_path . "/luna";
    my $image_path = $luna_path ."/images";

# The following section will unarchive attached files into the proper location.
    my $dir = "$CFG->{path_private}/templates/luna";
    mkdir $dir, 0777 unless -e $dir;
    mkdir $static_path, 0777 unless -e $static_path;
    mkdir $luna_path, 0777 unless -e $luna_path;
    mkdir $image_path, 0777 unless -e $image_path;
    foreach (@LUNA) {
        $FILES->{$_}->{path} = $luna_path;
        $FILES->{$_}->{chmod} = '0666';
    }
    my $file;
    foreach (keys %{$FILES}) {
        $file = $tar->get_file($_);
        $file->name("$FILES->{$_}->{path}/$_");
        unless (-e $file->name) {   # don't overwrite luna files
        	$file->write or return Plugins::Community::Luna_Templates->error("Unable to extract file '$FILES->{$_}->{path}/$_' : $GT::Tar::error", 'WARN');
        	chmod (oct($FILES->{$_}->{chmod}), $FILES->{$_}->{path}.'/'.$_);
        }
    }
    $CFG->{db_cgi_url} = $db_cgi_url;
    $CFG->{static_url} = $static_url;
    $CFG->{static_path} = $static_path;
    $CFG->save;
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -----------------------------------------------------------------------------
# This function removes the plugin.  Its first argument is also a plugin
# manager which you can use to register hooks, install files, add menu options,
# etc. You should return an HTML formatted string that will be displayed to the
# user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::Community::Luna_Templates::error
#
    my $mgr = shift;

    $mgr->uninstall_menu('Luna Templates', [['Template Set', 'community.cgi?do=plugin&plugin=Luna_Templates&func=changeTemplateSet']]);
    $mgr->uninstall_hooks('Luna_Templates', [['web_admin_page', 'PRE', 'Plugins::Community::Luna_Templates::admin_template', '']]);

    # delete the files

    foreach (keys %{$FILES}) {
#        next if ($_ =~ /(luna||images)/); # don't erase luna customizations
        unlink ("$FILES->{$_}->{path}/$_") or return Plugins::Community::Luna_Templates->error("Unable to delete file '$FILES->{$_}->{path}/$_': $GT::Tar::error", 'WARN');
    }

     $CFG->{system_template_set} = 'default';
     $CFG->save;
    ;
    return "The plugin has been successfully removed!";
}

1;